/*	Public domain	*/

#include <sys/types.h>

#include "queue.h"
#include "table.h"
#include "sockunion.h"
#include "maillist.h"
#include "message.h"
#include "sa.h"
#include "smtp.h"
#include "qmgr.h"
#include "local.h"
#include "policy.h"

#define Malloc(len) SF_Malloc(len)
#define Fatal SF_Fatal
#ifdef DEBUG
#define Debug SF_Debug
#else
#define Debug ((void)(0))
#endif

#if defined(__OpenBSD__) || defined(__NetBSD__) || defined(__FreeBSD__)
typedef socklen_t my_socklen_t;
#else
typedef int my_socklen_t;
#endif

#ifdef BENCHMARK
#define RDTSC(t) asm __volatile__ (".byte 0x0f, 0x31; " : "=A" (t))
#else
#define RDTSC(t) ((void)(0))
#endif

typedef enum {
	SF_NONE,
	SF_AND,
	SF_OR
} SF_LogicOp;

extern int sfPollInterval;
extern int sfPolicyServer;
extern char *sfHostSMTP, *sfPortSMTP;
extern char *sfReinHost, *sfReinPort;
extern FILE *sfLog;

void	 SF_Debug(const char *, ...);
void	*SF_Malloc(size_t);
void	 SF_Fatal(const char *, ...);
void	 SF_SetError(const char *, ...);
char	*SF_GetError(void);
void	 SF_EnterServerProc(const char *);
void	 SF_ExitServerProc(int);
